<?php

namespace Drupal\entity_workflow;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\workflows\State;
use Drupal\workflows\StateInterface;
use Drupal\workspaces\WorkspaceInterface;

/**
 * A value object representing a workflow state for Entity Workflow.
 */
class EntityWorkflowState extends State implements StateInterface {

  /**
   * {@inheritdoc}
   */
  public function label(ContentEntityInterface $entity = NULL, WorkspaceInterface $workspace = NULL) {
    $context = [
      'entity' => $entity,
      'state' => $this,
      'workspace' => $workspace,
    ];
    $label = $this->label;
    \Drupal::moduleHandler()->alter('entity_workflow_state_label', $label, $context);
    return $label;
  }

}
