<?php

namespace Drupal\entity_workflow\Plugin\views\argument;

use Drupal\Core\Database\Query\Condition;
use Drupal\views\Plugin\views\argument\ArgumentPluginBase;

/**
 * An argument handler for the source entity ID of transition logs.
 *
 * @ingroup views_argument_handlers
 *
 * @ViewsArgument("workflow_transition_log_source_entity_id")
 */
class SourceEntityId extends ArgumentPluginBase {

  /**
   * {@inheritdoc}
   */
  public function query($group_by = FALSE) {
    $this->ensureMyTable();
    // The source entity ID can be either an integer or a string, so we have to
    // check both 'entity_id' and 'entity_id_string' fields.
    $db_or = new Condition('OR');
    $condition = $db_or
      ->condition("$this->tableAlias.entity_id", $this->argument)
      ->condition("$this->tableAlias.entity_id_string", $this->argument);
    $this->query->addWhere(0, $condition);
  }

}
